/**
 * CInput - 表单项，文本输入框
 * @author Tevin
 */

<template>
    <view
        class="c-input"
        :class="unit?'c-input-unit':''"
    >
        <AtInput
            :name="itemRes.name"
            :title="itemRes.label"
            :type="type"
            :placeholder="placeholder"
            :required="itemRes.required"
            :error="itemRes.error"
            :cursorSpacing="0"
            :value="value"
            :onChange="evt => hanldeChange(evt)"
        >
            <slot v-if="!unit" />
            <text
                class="c-input-unit-text"
                v-if="unit"
            >{{unit}}</text>
        </AtInput>
    </view>
</template>

<script>
import { AtInput } from 'taro-ui-vue';
import './cInput.scss';

export default {
    name: 'CInput',
    components: {
        AtInput,
    },
    props: {
        // 表单数据资源（表单组件内部机制专用）
        itemRes: Object,
        // 输入框类型，text、number、password、phone、idcard、digit
        type: String,
        // 占位提示
        placeholder: String,
        // 输入框单位
        unit: String,
    },
    computed: {
        value() {
            return (this.itemRes.formData[this.itemRes.name] || '').replace(
                /[\n\r]/g,
                ''
            );
        },
    },
    methods: {
        hanldeChange(evt) {
            // 小程序中，可以粘贴换行符进来
            const changeValue = (evt || '').replace(/[\n\r]/g, '');
            this.itemRes.onChange(changeValue);
        },
    },
    mounted() {},
};
</script>